> This page is for Developers.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://zuora.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://zuora.ferndocs.com/_mcp/server.

# Create a product rate plan definition

POST https://rest.test.zuora.com/v1/product-rateplan-definitions
Content-Type: application/json

Creates a product rate plan definition to use a charge in a product rate plan.

In the request, you must specify either the unique ID or number of both the charge and the product rate plan to add the specified charge to a specific rate plan.

**Note**: This operation requires the [Attribute-based Pricing](https://knowledgecenter.zuora.com/Zuora_Billing/Build_products_and_prices/Attribute_based_pricing/AA_Overview_of_Attribute-based_Pricing) feature to be enabled, which is in the **Early Adopter** phase. 


Reference: https://zuora.ferndocs.com/developers/api-reference/zuora-api/legacy-v1-products/product-rate-plan-definitions/post-create-product-rate-plan-definition

## Authentication

- `Authorization` header (bearer token, required) — Use `Bearer {{token}}` in the `Authorization` header for authentication.

## Servers

- `https://rest.test.zuora.com` (US Developer & Central Sandbox (incl. Test Drive), default)
- `https://rest.sandbox.na.zuora.com` (US API Sandbox Cloud 1)
- `https://rest.apisandbox.zuora.com` (US API Sandbox Cloud 2)
- `https://rest.na.zuora.com` (US Production Cloud 1)
- `https://rest.zuora.com` (US Production Cloud 2)
- `https://rest.test.eu.zuora.com` (EU Developer & Central Sandbox)
- `https://rest.sandbox.eu.zuora.com` (EU API Sandbox)
- `https://rest.eu.zuora.com` (EU Production)
- `https://rest.test.ap.zuora.com` (APAC Developer & Central Sandbox)
- `https://rest.ap.zuora.com` (APAC Production)

## Request

### Headers

- `Idempotency-Key` (string, optional) — Specify a unique idempotency key if you want to perform an idempotent POST or PATCH request. Do not use this header in other request types. With this header specified, the Zuora server can identify subsequent retries of the same request using this value, which prevents the same operation from being performed multiple times by accident.
- `Accept-Encoding` (string, optional) — Include the `Accept-Encoding: gzip` header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a `Content-Encoding` header with the compression algorithm so that your client can decompress it.
- `Content-Encoding` (string, optional) — Include the `Content-Encoding: gzip` header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
- `Zuora-Track-Id` (string, optional) — A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (`:`), semicolon (`;`), double quote (`"`), and quote (`'`).
- `Zuora-Entity-Ids` (string, optional) — An entity ID. If you have [Zuora Multi-entity](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/Multi-entity) enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
- `Zuora-Version` (string, optional) — The minor API version. For a list of available minor versions, see [API upgrades](https://developer.zuora.com/v1-api-reference/api-upgrades/).

### Body (application/json)

This endpoint expects a POSTRatePlanDefinitionRequest.

- `productRatePlanChargeId` (string, optional) — The unique ID of the product rate plan charge to be used in the product rate plan.
- `productRatePlanChargeNumber` (string, optional) — The unique number (natural key) of the product rate plan charge to be used in the product rate plan.
- `productRatePlanId` (string, optional) — The unique ID of the product rate plan that uses this rate plan definition.
- `productRatePlanNumber` (string, optional) — The unique number (natural key) of the product rate plan that uses this rate plan definition.

## Response

### 200

OK

- `id` (string, optional) — The unique ID of the product charge definition.
- `success` (boolean, optional) — Indicates whether the request succeeded.

## Errors

### 500 Internal Server Error

Internal Server Error

- `reasons` (list of ErrorResponseReasonsItems, optional)

### 400 Client Request Error

Request Errors

- `processId` (string, optional) — The ID of the process that handles the operation.
- `reasons` (list of CommonResponseReasonsItems, optional) — The container of the error code and message. This field is available only if the `success` field is `false`.
- `requestId` (string, optional) — Unique identifier of the request.
- `success` (boolean, optional) — Indicates whether the call succeeded.

## Types

### ErrorResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

### CommonResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

## Examples

**Request**

```json
{
  "productRatePlanChargeId": "2c9890e489f227bd0189f22f3482001f",
  "productRatePlanChargeNumber": "PRPC-00000001",
  "productRatePlanId": "2c9890678b1ca909018b1caea5c30000",
  "productRatePlanNumber": "PRP-00000008"
}
```

**Response**

```json
{
  "id": "2c9890f78aba5c16018ababa00120019",
  "success": true
}
```

**SDK Code**

```python response
import requests

url = "https://rest.test.zuora.com/v1/product-rateplan-definitions"

payload = {
    "productRatePlanChargeId": "2c9890e489f227bd0189f22f3482001f",
    "productRatePlanChargeNumber": "PRPC-00000001",
    "productRatePlanId": "2c9890678b1ca909018b1caea5c30000",
    "productRatePlanNumber": "PRP-00000008"
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript response
const url = 'https://rest.test.zuora.com/v1/product-rateplan-definitions';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"productRatePlanChargeId":"2c9890e489f227bd0189f22f3482001f","productRatePlanChargeNumber":"PRPC-00000001","productRatePlanId":"2c9890678b1ca909018b1caea5c30000","productRatePlanNumber":"PRP-00000008"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go response
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/v1/product-rateplan-definitions"

	payload := strings.NewReader("{\n  \"productRatePlanChargeId\": \"2c9890e489f227bd0189f22f3482001f\",\n  \"productRatePlanChargeNumber\": \"PRPC-00000001\",\n  \"productRatePlanId\": \"2c9890678b1ca909018b1caea5c30000\",\n  \"productRatePlanNumber\": \"PRP-00000008\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby response
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/v1/product-rateplan-definitions")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"productRatePlanChargeId\": \"2c9890e489f227bd0189f22f3482001f\",\n  \"productRatePlanChargeNumber\": \"PRPC-00000001\",\n  \"productRatePlanId\": \"2c9890678b1ca909018b1caea5c30000\",\n  \"productRatePlanNumber\": \"PRP-00000008\"\n}"

response = http.request(request)
puts response.read_body
```

```java response
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://rest.test.zuora.com/v1/product-rateplan-definitions")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"productRatePlanChargeId\": \"2c9890e489f227bd0189f22f3482001f\",\n  \"productRatePlanChargeNumber\": \"PRPC-00000001\",\n  \"productRatePlanId\": \"2c9890678b1ca909018b1caea5c30000\",\n  \"productRatePlanNumber\": \"PRP-00000008\"\n}")
  .asString();
```

```php response
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://rest.test.zuora.com/v1/product-rateplan-definitions', [
  'body' => '{
  "productRatePlanChargeId": "2c9890e489f227bd0189f22f3482001f",
  "productRatePlanChargeNumber": "PRPC-00000001",
  "productRatePlanId": "2c9890678b1ca909018b1caea5c30000",
  "productRatePlanNumber": "PRP-00000008"
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp response
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/v1/product-rateplan-definitions");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"productRatePlanChargeId\": \"2c9890e489f227bd0189f22f3482001f\",\n  \"productRatePlanChargeNumber\": \"PRPC-00000001\",\n  \"productRatePlanId\": \"2c9890678b1ca909018b1caea5c30000\",\n  \"productRatePlanNumber\": \"PRP-00000008\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift response
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "productRatePlanChargeId": "2c9890e489f227bd0189f22f3482001f",
  "productRatePlanChargeNumber": "PRPC-00000001",
  "productRatePlanId": "2c9890678b1ca909018b1caea5c30000",
  "productRatePlanNumber": "PRP-00000008"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/v1/product-rateplan-definitions")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```